/******************************************************************************
 * File Name   : MX_Device.h
 * Date        : 11/03/2024 09:15:15
 * Description : STM32Cube MX parameter definitions
 * Note        : This file is generated by STM32CubeMX (DO NOT EDIT!)
 ******************************************************************************/

#ifndef __MX_DEVICE_H
#define __MX_DEVICE_H

/*---------------------------- Clock Configuration ---------------------------*/

#define MX_LSI_VALUE                            32000
#define MX_LSE_VALUE                            32768
#define MX_HSI_VALUE                            16000000
#define MX_HSE_VALUE                            8000000
#define MX_SYSCLKFreq_VALUE                     80000000
#define MX_HCLKFreq_Value                       80000000
#define MX_FCLKCortexFreq_Value                 80000000
#define MX_CortexFreq_Value                     80000000
#define MX_AHBFreq_Value                        80000000
#define MX_APB1Freq_Value                       80000000
#define MX_APB2Freq_Value                       80000000
#define MX_APB1TimFreq_Value                    80000000
#define MX_APB2TimFreq_Value                    80000000
#define MX_PWRFreq_Value                        80000000
#define MX_RTCFreq_Value                        32000
#define MX_USBFreq_Value                        48000000
#define MX_WatchDogFreq_Value                   32000
#define MX_MCO1PinFreq_Value                    80000000

/*-------------------------------- DMA        --------------------------------*/

#define MX_DMA                                  1

/* NVIC Configuration */

/* NVIC DMA2_Channel4_IRQn */
#define MX_DMA2_Channel4_IRQn_interruptPremptionPriority 0
#define MX_DMA2_Channel4_IRQn_PriorityGroup     NVIC_PRIORITYGROUP_4
#define MX_DMA2_Channel4_IRQn_Subriority        0

/* NVIC DMA2_Channel5_IRQn */
#define MX_DMA2_Channel5_IRQn_interruptPremptionPriority 0
#define MX_DMA2_Channel5_IRQn_PriorityGroup     NVIC_PRIORITYGROUP_4
#define MX_DMA2_Channel5_IRQn_Subriority        0

/*-------------------------------- SDMMC1     --------------------------------*/

#define MX_SDMMC1                               1

/* GPIO Configuration */

/* Pin PD2 */
#define MX_SDMMC1_CMD_Pin                       PD2
#define MX_SDMMC1_CMD_GPIOx                     GPIOD
#define MX_SDMMC1_CMD_GPIO_PuPd                 GPIO_NOPULL
#define MX_SDMMC1_CMD_GPIO_Speed_High_Default   GPIO_SPEED_FREQ_VERY_HIGH
#define MX_SDMMC1_CMD_GPIO_Pin                  GPIO_PIN_2
#define MX_SDMMC1_CMD_GPIO_AF                   GPIO_AF12_SDMMC1
#define MX_SDMMC1_CMD_GPIO_Mode                 GPIO_MODE_AF_PP

/* Pin PC8 */
#define MX_SDMMC1_D0_Pin                        PC8
#define MX_SDMMC1_D0_GPIOx                      GPIOC
#define MX_SDMMC1_D0_GPIO_PuPd                  GPIO_NOPULL
#define MX_SDMMC1_D0_GPIO_Speed_High_Default    GPIO_SPEED_FREQ_VERY_HIGH
#define MX_SDMMC1_D0_GPIO_Pin                   GPIO_PIN_8
#define MX_SDMMC1_D0_GPIO_AF                    GPIO_AF12_SDMMC1
#define MX_SDMMC1_D0_GPIO_Mode                  GPIO_MODE_AF_PP

/* Pin PC9 */
#define MX_SDMMC1_D1_Pin                        PC9
#define MX_SDMMC1_D1_GPIOx                      GPIOC
#define MX_SDMMC1_D1_GPIO_PuPd                  GPIO_NOPULL
#define MX_SDMMC1_D1_GPIO_Speed_High_Default    GPIO_SPEED_FREQ_VERY_HIGH
#define MX_SDMMC1_D1_GPIO_Pin                   GPIO_PIN_9
#define MX_SDMMC1_D1_GPIO_AF                    GPIO_AF12_SDMMC1
#define MX_SDMMC1_D1_GPIO_Mode                  GPIO_MODE_AF_PP

/* Pin PC10 */
#define MX_SDMMC1_D2_Pin                        PC10
#define MX_SDMMC1_D2_GPIOx                      GPIOC
#define MX_SDMMC1_D2_GPIO_PuPd                  GPIO_NOPULL
#define MX_SDMMC1_D2_GPIO_Speed_High_Default    GPIO_SPEED_FREQ_VERY_HIGH
#define MX_SDMMC1_D2_GPIO_Pin                   GPIO_PIN_10
#define MX_SDMMC1_D2_GPIO_AF                    GPIO_AF12_SDMMC1
#define MX_SDMMC1_D2_GPIO_Mode                  GPIO_MODE_AF_PP

/* Pin PC11 */
#define MX_SDMMC1_D3_Pin                        PC11
#define MX_SDMMC1_D3_GPIOx                      GPIOC
#define MX_SDMMC1_D3_GPIO_PuPd                  GPIO_NOPULL
#define MX_SDMMC1_D3_GPIO_Speed_High_Default    GPIO_SPEED_FREQ_VERY_HIGH
#define MX_SDMMC1_D3_GPIO_Pin                   GPIO_PIN_11
#define MX_SDMMC1_D3_GPIO_AF                    GPIO_AF12_SDMMC1
#define MX_SDMMC1_D3_GPIO_Mode                  GPIO_MODE_AF_PP

/* Pin PC12 */
#define MX_SDMMC1_CK_Pin                        PC12
#define MX_SDMMC1_CK_GPIOx                      GPIOC
#define MX_SDMMC1_CK_GPIO_PuPd                  GPIO_NOPULL
#define MX_SDMMC1_CK_GPIO_Speed_High_Default    GPIO_SPEED_FREQ_VERY_HIGH
#define MX_SDMMC1_CK_GPIO_Pin                   GPIO_PIN_12
#define MX_SDMMC1_CK_GPIO_AF                    GPIO_AF12_SDMMC1
#define MX_SDMMC1_CK_GPIO_Mode                  GPIO_MODE_AF_PP

/* DMA Configuration */

/* DMA SDMMC1_TX */
#define MX_SDMMC1_TX_DMA_DMA_Handle
#define MX_SDMMC1_TX_DMA_Instance               DMA2_Channel4
#define MX_SDMMC1_TX_DMA_NoTestForDmaSupport    false
#define MX_SDMMC1_TX_DMA_Priority               DMA_PRIORITY_LOW
#define MX_SDMMC1_TX_DMA_PeriphDataAlignment    DMA_PDATAALIGN_WORD
#define MX_SDMMC1_TX_DMA_MemDataAlignment       DMA_MDATAALIGN_WORD
#define MX_SDMMC1_TX_DMA_Mode                   DMA_NORMAL
#define MX_SDMMC1_TX_DMA_Request                DMA_REQUEST_7
#define MX_SDMMC1_TX_DMA_Direction              DMA_MEMORY_TO_PERIPH
#define MX_SDMMC1_TX_DMA_PeriphInc              DMA_PINC_DISABLE
#define MX_SDMMC1_TX_DMA_MemInc                 DMA_MINC_ENABLE
#define MX_SDMMC1_TX_DMA_IpInstance

/* DMA SDMMC1_RX */
#define MX_SDMMC1_RX_DMA_DMA_Handle
#define MX_SDMMC1_RX_DMA_Instance               DMA2_Channel5
#define MX_SDMMC1_RX_DMA_NoTestForDmaSupport    false
#define MX_SDMMC1_RX_DMA_Priority               DMA_PRIORITY_LOW
#define MX_SDMMC1_RX_DMA_PeriphDataAlignment    DMA_PDATAALIGN_WORD
#define MX_SDMMC1_RX_DMA_MemDataAlignment       DMA_MDATAALIGN_WORD
#define MX_SDMMC1_RX_DMA_Mode                   DMA_NORMAL
#define MX_SDMMC1_RX_DMA_Request                DMA_REQUEST_7
#define MX_SDMMC1_RX_DMA_Direction              DMA_PERIPH_TO_MEMORY
#define MX_SDMMC1_RX_DMA_PeriphInc              DMA_PINC_DISABLE
#define MX_SDMMC1_RX_DMA_MemInc                 DMA_MINC_ENABLE
#define MX_SDMMC1_RX_DMA_IpInstance

/* NVIC Configuration */

/* NVIC SDMMC1_IRQn */
#define MX_SDMMC1_IRQn_interruptPremptionPriority 0
#define MX_SDMMC1_IRQn_PriorityGroup            NVIC_PRIORITYGROUP_4
#define MX_SDMMC1_IRQn_Subriority               0

/*-------------------------------- SYS        --------------------------------*/

#define MX_SYS                                  1

/* GPIO Configuration */

/*-------------------------------- NVIC       --------------------------------*/

#define MX_NVIC                                 1

/*-------------------------------- GPIO       --------------------------------*/

#define MX_GPIO                                 1

/* GPIO Configuration */

#endif  /* __MX_DEVICE_H */

